source("/Users/bamba/Geoloc/Fichier_R/bestline.R")
source("/Users/bamba/Geoloc/Fichier_R/airepolygone.R")
source("/Users/bamba/Geoloc/Fichier_R/Newcrosscircle.R")
source("/Users/bamba/Geoloc/Fichier_R/Goodpoints.R")
source("/Users/bamba/Geoloc/Fichier_R/Runangle.R")
source("/Users/bamba/Geoloc/Fichier_R/Runangle-without-plot.R")

##### ptlonlat ()
ptlonlat <- function(ln1,lt1,dist,tcin)
{
# radius of the earth in km; convert distance from km to radians
	d<-dist/6378.16
# convert angles from degrees to radians
	lon1<-pi*(ln1/180)
	lat1<-pi*(lt1/180)
	tc<-pi*(tcin/180)
	lat<-asin(sin(lat1)*cos(d)+cos(lat1)*sin(d)*cos(tc))
	dlon<-atan2(sin(tc)*sin(d)*cos(lat1),cos(d)-sin(lat1)*sin(lat))
	lon<-((lon1-dlon +pi) %% (2*pi))-pi
	c(180*lon/pi,180*lat/pi)
}

##### plotcircle()
plotcircle <- function (lon,lat,r)
{
# this function gives the coordinates of points which form a given circle
# r is in km
# lon, lat in degrees
	angles<-360*((1:101)/100)
	points<-sapply(angles,function(x){ptlonlat(lon,lat,r,x)})
	t(points)
}

##### plotcircleV2()
plotcircleV2 <- function(lon,lat,r)
# r is in km
# lon, lat in degrees
{
	angles<-360*((1:101)/100)
	points<-sapply(angles,function(x){ptlonlat(lon,lat,r,x)})
	lines(t(points),col="blue")
	title(sub="The area of the tagged cercle represents the confidence region", col.sub="blue",cex.sub=1)
}

#### cross()
cross <- function (lon1,lat1,R1,lon2,lat2,R2)
{
	distC1C2<-calculdist(deg2rad(lon1),deg2rad(lat1),deg2rad(lon2),deg2rad(lat2))
	if(abs(R1-R2)<distC1C2 & distC1C2<(R1+R2)) rep<-1
        else rep<-0
			rep
}

### findsegments()
findsegments <- function (lineA,RayonB,lon2,lat2)
{
#           cat("line A= ",lineA," longuuer= ",length(lineA[,1]),"\n") 
    pt<-matrix(0,nc=4)
	extremite1<-calculdist(deg2rad(lineA[1,1]),deg2rad(lineA[1,2]),deg2rad(lon2),deg2rad(lat2))
	extremite2<-calculdist(deg2rad(lineA[2,1]),deg2rad(lineA[2,2]),deg2rad(lon2),deg2rad(lat2))
# un segment de droite coupe un autre segment de droite si le premier point du segment est a une
# distance infErieure au rayon du cercle 2 et le deuxiEme point du segment est  une distance 
# supErieure au cercle 2   
	if((extremite1<RayonB & extremite2>RayonB) | (extremite1>RayonB & extremite2<RayonB)){
		pt<-c(lineA[1,1],lineA[1,2],lineA[2,1],lineA[2,2])
	}
	
	for(i in 2:100){
        extremite1<-calculdist(deg2rad(lineA[i,1]),deg2rad(lineA[i,2]),deg2rad(lon2),deg2rad(lat2))
        extremite2<-calculdist(deg2rad(lineA[i+1,1]),deg2rad(lineA[i+1,2]),deg2rad(lon2),deg2rad(lat2))
		if((extremite1<RayonB & extremite2>RayonB) | (extremite1>RayonB & extremite2<RayonB)){
			pointcross<-c(lineA[i,1],lineA[i,2],lineA[i+1,1],lineA[i+1,2])
			pt<-rbind(pt,pointcross)
			
		}
	}
	pt
}

### eqdroite()
eqdroite <- function (x1,y1,x2,y2)
{
# givesa and b of the equation  y=ax+b
	a<- (y1-y2)/(x1-x2)
	b<- y2-a*x2
#       cat("y= ",a,"x +",b,"\n")
	mat<-c(a,b)
	mat
}

### pointinter()
pointinter <- function (eq1,eq2,lon1,lon11,lon2,lon22)
{ x<- (eq2[2]-eq1[2])/(eq1[1]-eq2[1])
	y<- (eq2[1]*x)+ eq2[2]
#cat("bprim=  ",eq2[2],"b= ",eq1[2],"\n")
#cat("a-aprim= ",(eq1[1]-eq2[1]),"\n")
	pt<-c("init","init")
	matlon<-matrix(c(lon1,lon11,lon2,lon22),nr=1)
	maxlon<-max(matlon)
	minlon<-min(matlon)
#cat("x= ",x,"min =",minlon,"\n")
#cat("x= ",x,"max =",maxlon,"\n")
	if(x>=minlon & x<=maxlon) pt<-c(x,y)
		pt
}

#### calculdist()
calculdist <- function(lon1,lat1,lon2,lat2){
	d=2*asin(sqrt((sin((lat1-lat2)/2))^2 + cos(lat1)*cos(lat2)*(sin((lon2-lon1)/2))^2))
	d<-d*6371
	d
}

#### deg2rad()
deg2rad <- function(x){
	y<-(x*pi)/180
	y
}

#### rad2deg
rad2deg <-  function (angle){
	angdegre<-(180/pi)*angle
	angdegre
}

#### degre2km
degre2km <- function (points){
	lon2km<-matrix(0,nc=1,nr=(length(points[,1])-1))
	lat2km<-matrix(0,nc=1,nr=(length(points[,1])-1))
	for(i in 2:length(points[,1])){
#cat("i= ",i,"\n")
		D1<-calculdist(deg2rad(points[1,1]),deg2rad(points[1,2]),deg2rad(points[i,1]),deg2rad(points[i,2]))
#distance of 1 degre longitude en km
		D2<-calculdist(deg2rad(points[1,1]+1),deg2rad(points[1,2]),deg2rad(points[i,1]),deg2rad(points[i,2]))
		lon2km[i]<-abs(D2-D1)
		
#distance of 1 degre latitude en km
		D3<-calculdist(deg2rad(points[1,1]),deg2rad(points[1,2]+1),deg2rad(points[i,1]),deg2rad(points[i,2]))
		lat2km[i]<-abs(D1-D3)
		
	}
	dlon<-mean(lon2km)
	dlat<-mean(lat2km)
#cat("dlon= ",dlon,"\n")
#cat("dlat= ",dlat,"\n")
#conversion des longitudes  en km
	points[,1]<-points[,1]*dlon
#conversion des latitudes en km
	points[,2]<-points[,2]*dlat
	points<-rbind(points,c(dlon,dlat))
	points
}


#### Tracepolygone
Tracepolygone <-function(mat){
	long<-length(mat[,1])
	nbelement<-length(chull(mat))
	if(nbelement==long){
# on trace les sommets du polygone
		for(i in 1:long){
			points(mat[i,1],mat[i,2],pch=20,cex=0.5)
		}
# on joint les sommet du polygone
		for(j in 1:(long-1)){
			lines(c(mat[j,1],mat[(j+1),1]),c(mat[j,2],mat[(j+1),2]),col="blue")
		}
# joindre le dernier somment du polygone au premier point
		lines(c(mat[long,1],mat[1,1]),c(mat[long,2],mat[1,2]),col="blue")
		
		
		
	}
	title(sub="The area of the tagged polygon represents the confidence region", col.sub="blue",cex.sub=1)
}

#### calculangle()
calculangle <- function(lon1,lat1,lon2,lat2){
	lon1<-deg2rad(lon1)
	lat1<-deg2rad(lat1)
	lon2<-deg2rad(lon2)
	lat2<-deg2rad(lat2)
# As stated in the introduction, North latitudes and West longitudes are
# treated as positive, and South latitudes and East longitudes negative.
# It's easier to go with the flow, but if you prefer another convention
# you can change the signs in the formulae.
# http://williams.best.vwh.net/avform.htm#GCF
# on rend positive les longitudes ouest
# we do lon2-lon1 because  longitude west  is considered negative
	tc1=mod(atan2(sin(lon2-lon1)*cos(lat2),cos(lat1)*sin(lat2)-sin(lat1)*cos(lat2)*cos(lon2-lon1)), 2*pi)
	tc1
}
### Tracebestline()
Tracebestline <- function (z,dists,rawdelays) {
	plot(dists[z,],rawdelays[z,],type="n",xlab=paste("distance (km)"),ylab=paste("delay (ms)"))
	points(dists[z,][-z],rawdelays[z,][-z])
#text(dists[z,][-z],rawdelays[z,][-z],cex=0.7,pos=1)
	x<-fonctx(bls[z,2],15000,bls[z,1])
	lines(c(0,15000),c(bls[z,1],x),col="red")
}

### fonctx 
fonctx  <-  function (a,x,b)
{
	y<- a*x + b
	y
	
}
### mod()
mod <- function (y,x)
{
# If you have a floor function (int in Excel), that returns
# floor(x)= "largest integer less than x" e.g. floor(-2.3)=-3
# and floor(2.3) =2
	resultat<- y-x*floor(y/x)
	resultat
}

