# nblandmarks contains the number of used landmarks
nblandmarks<-length(rtt)
# Seeking failed landmarks during the RTT measurements step
violators<-which(rtt==0)
if(length(violators)==0){
	# We choose all our set of landmarks
	goodlandRTT<-(1:nblandmarks)
}
if(length(violators)!=0){ 
	# Remove landmarks which fail
	goodlandRTT<-(1:nblandmarks)[-violators]
}
# delays_{iT} = (delay_{i_T} - b_i)/m_i - (size_of_packet/min_bw).(1/m_i)  (1)
# delay = rawdelays, b_i = bls[,1], m_i = bls[,2], size_of_packet = 1460 octet = 11680 bit, 
# min_bw is the measured bottleneck bandwidth between landmark i and target host T
#	delays[i,]<-(delays[i,]-bls[,1])/bls[,2] - matbandwidth[i,]/bls[,2]

# b_i represents the intercept of the bestline of the ith landmark 
# m_i represents the slope of the bestline of the ith landmark
# each landmark computes its own bestline offline


# Compute the geographic distance constraint delays_{iT}
#
delays<-(rtt[goodlandRTT] - bls[goodlandRTT,1])/bls[goodlandRTT,2] 


#
# si delay_{iT] == b_i => delays_{iT} < 0 d'apres l'equation (1)
# si delay_{iT} < b_i par dfinition delays_{iT]<-0 
# alors il faut mettre delays_{iT} == 0 car une distance n'est jamais negative
# dans la realite cela signifie que les 2 points sont situes au mme endroit.
#negatif<-which(delays<0)
#delays[negatif]<-0
delays <- abs(delays)
