#!/usr/bin/perl
use warnings;
my %to_be_localized;
my @ligne;
open(G,"to_be_localized.txt") or die "cannot open file $!\n";
while(<G>){
	@ligne = split(" ");
	$to_be_localized{$ligne[0]}= "";
}
localize();

#######################################
# Search_localized_nodes
#######################################

sub localize {
	my $longitude;
	my $latitude;
	foreach $router (keys %to_be_localized){
		#print $router."\n";
		my $pssh = "pssh -h Landmarks.txt -l upmc_2tierVivaldi -o Rslt-ping-target/$router 'ping -qc 5 $router | grep min' ";
		system("./pssh_ping.sh $router");
		# we open the file that will contain the results of ping
		open(FicRslt,">RTT-probes-targets/$router");
		my $nblandmark=0;
		my $faillandmark=0;
		# $counter, variable that shows if the targeted host answers to ping
		my $counter = 0;
		open(FicLand,"<Landmarks.txt");
		while (<FicLand>){
			$nblandmark++ ;
			my @line = split(" ");
			my $landmark = $line[0];
			# print "reading file landmark: $landmark\n";
			if (-z "Rslt-ping-target/$router/$landmark" || ! ( -e "Rslt-ping-target/$router/$landmark")){
				# failed ping measurements
				print FicRslt "$landmark 0\n";
				$faillandmark++ ;
			}
			else{
				open(FicRTT,"Rslt-ping-target/$router/$landmark");
				while(<FicRTT>){
					my @raw= split();
					# seek if the current line contains RTT measurements
					if ($raw[0] eq "rtt"){
						# we decrease the variable counter if the ping towards the target has worked
						$counter-- ;
						my $bloc_delay = $raw[3];
						my @measures = split("\/",$bloc_delay);
						my $min_rtt = $measures[0];
						print FicRslt  "$landmark $min_rtt\n";
					}
					else{
						# normally will not happen.
						print FicRslt  "$landmark 0\n";
						$faillandmark++ ;
					}
				}
			}
		}
		close(FicRTT);
		close(FicLand);
		close(FicRslt);
		# case where the target is not localizable
		if ( ($counter == 0) or ($faillandmark == $nblandmark)){
			$longitude = "";
			$latitude = "";
		}
		# case where the half of landmarks have their measurements failed
		elsif (($nblandmark - $faillandmark) < $nblandmark/2){
			$longitude = "";
			$latitude = "";
		}
		else{
			# we call the R  script which provides the geographic location of the target hostr
			system("./Shell2R.sh RTT-probes-targets/$router $router");
		}
		open (H,">>Failed_landmarks.txt");
		print  H "$router $faillandmark\n";
		close(H);
	}	
}

